// coded by scarebyte (uCF)
// mail: scarebyte@youceff.com
//
// application: x3chun's Crypto KeyGenMe #2
// url:         http://www.x3chun.wo.to/
// protection:  modified md4 and extended tea
// uses:        md4, stea


const
// change this constants for the keygen
// Labels
 lb_appname  = 'uCF - x3chun''s Crypto KeyGenMe #2';
 lb_done     = 'keygen done by scarebyte';
 lb_name     = 'Name:';
 lb_comp     = 'Company:';
// Editfields
 ed_name     = 'not used';
 ed_comp     = '';
// Conditions 
 Name_used   = true;
 Comp_used   = false;
 genonchange = true;

// key - routine

(***************************************************************)
function int2hex(c: cardinal): string;
const ctab = '0123456789ABCDEF';
begin
 if c shr 4 = 0
    then int2hex := ctab[(c mod 16) + 1]
    else int2hex := int2hex(c shr 4) + ctab[(c mod 16) + 1];
end;
(***************************************************************)
function fillstr(s: string; c: char; pos, digits: byte): string;
begin
 result := s;
 while length(result) <> digits do
       insert(c, result, pos);
end;
(***************************************************************)
function litte_endian(a: longword): longword; assembler;
asm
 bswap eax
end;
(***************************************************************)
function generate(uName: string): string;
var context : PMD4_CTX;    // MD4
    digests : PMD4Digest;  // MD4
    t       : TTEA;        // TEA
    k       : longword;
begin

  // Part1: MD4 (name) .. i modified the md4.pas
  GetMem(context, sizeof(TMD4_CTX));
  GetMem(digests, sizeof(TMD4Digest));
  MD4Init(context);
  MD4Update(context, pchar(uName), length(uName));
  MD4Final(digests, context);

  // Part2: extended TEA .. encode
  with t do begin
       move(digests[ 0], k, sizeof(k)); key[0]  := k;
       move(digests[ 4], k, sizeof(k)); key[1]  := k;
       move(digests[ 8], k, sizeof(k)); key[2]  := k;
       move(digests[12], k, sizeof(k)); key[3]  := k;
       data[0] := $78336368;
       data[1] := $756E3A29;
       end;

  FreeMem(context, sizeof(TMD4_CTX));
  FreeMem(digests, sizeof(TMD4Digest));

  tea(t, 32); // encrypt data with tea

  result := fillstr(int2hex(t.data[0]), '0', 1, 8) +
            fillstr(int2hex(t.data[1]), '0', 1, 8);
end;
(***************************************************************)


// read textfields

procedure GenGoodCode;
var Text  : pchar;
    Lang  : integer;
begin

 Lang := GetWindowTextLengthA(txtField1);

 if Lang > 2 then begin
    GetMem (Text, Lang + 1);
    GetWindowTextA (txtField1, Text, Lang + 1);

    SetWindowText(txtGoodCode,PChar(generate(Text)));

    FreeMem(Text, Lang + 1);
    End
 else
    SetWindowText(txtGoodCode, 'I need more letters ...');
end;